<?php
/**
 * Created by PhpStorm.
 * User: jmp
 * Date: 21-07-2016
 * Time: 16:59
 */

namespace PTPay\MeoWallet\SDK\Resources;


class MB extends ApiResource
{

    /**
     * Default expiration days for new references
     */
    const DEFAULT_MB_EXPIRATION_DAYS = 2;

    /**
     * MB constructor.
     * @param \PTPay\MeoWallet\SDK\Api $api
     */
    public function __construct($api)
    {
        parent::__construct($api);
    }

    /**
     * Create MB reference data
     * @param float $amount
     * @param string $extInvoiceId
     * @param string $currency
     * @param string $expires
     * @return array
     * @throws \PTPay\MeoWallet\SDK\Exceptions\ApiResponseException
     */
    public function createReference($amount, $extInvoiceId, $currency = 'EUR', \DateTime $expires = null)
    {

        if (!$expires) {
            $expiresDate = new \DateTime();
            $expires = $expiresDate->modify("+" . self::DEFAULT_MB_EXPIRATION_DAYS . " day");
        }
        $expires = $expires->format('c');

        $requestData = [
            'amount'        => strval(round($amount,2)),
            'ext_invoiceid' => strval($extInvoiceId),
            'currency'      => strval($currency),
            'expires'       => strval($expires)
        ];

        $response = $this->api->call('POST', '/mb/pay', $requestData);

        return $response->getDataAsArray();
    }

}